package com.ruoyi.framework.task;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.ruoyi.project.hit.service.PupuEquipmentService;
import com.ruoyi.project.hit.util.Util1;
import com.ruoyi.project.hit.util.webSocket.WsServerEndpoint;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.ruoyi.common.utils.StringUtils;

import javax.websocket.EndpointConfig;
import java.util.HashMap;
import java.util.Map;

/**
 * 定时任务调度测试
 * 
 * @author ruoyi
 */
@Component("ryTask")
public class RyTask
{
    @Autowired
    private WsServerEndpoint wsServerEndpoint;
    @Autowired
    private PupuEquipmentService pupuEquipmentService;

    public void ryMultipleParams(String s, Boolean b, Long l, Double d, Integer i)
    {
        System.out.println(StringUtils.format("执行多参方法： 字符串类型{}，布尔类型{}，长整型{}，浮点型{}，整形{}", s, b, l, d, i));
    }

    public void ryParams(String params)
    {
        System.out.println("执行有参方法：" + params);
    }

    public void ryNoParams()
    {
        System.out.println("执行无参方法");
    }

    //定时任务，每15s对设备进行一次检测，超过30s未运行，返回异常信息给前端，同时将该设备运行状态改为停用
    public void reportCurrentTime1() {
        long l = System.currentTimeMillis();
        Map<Integer, Long> upsMap = Util1.upsMap;
        for (Map.Entry<Integer, Long> entry : upsMap.entrySet()) {
            if(l-entry.getValue()>=30000){
                System.out.println(entry.getKey());
                //更新设备状态
                pupuEquipmentService.updateEquipmentStatus(entry.getKey(),1);
//                WsServerEndpoint wsServerEndpoint=new WsServerEndpoint();
                try {
                    //向前端传输异常信息
                    wsServerEndpoint.sendAllUser("id"+entry.getKey()+"设备异常");
                }  catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }
    }
}
