package com.ruoyi.project.hit.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.project.hit.domain.PupuEquipment;
import com.ruoyi.project.hit.service.PupuEquipmentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/hit/equipment")
public class PupuEquipmentController extends BaseController {
    @Autowired
    private PupuEquipmentService pupuEquipmentService;

    /**
     * 设备新增
     * @param pupuEquipment
     * @param userId 用户id（用于日志生成时记录操作人员）
     * @return
     */
    @PutMapping("/add/{userId}")
    public AjaxResult add(
            @RequestBody PupuEquipment pupuEquipment,
            @PathVariable(value = "userId") Integer userId){
        return toAjax(pupuEquipmentService.add(pupuEquipment,userId));
    }

    /**
     * 设备删除
     * @param equipmentId
     * @param userId 用户id（用于记录执行删除操作的用户id）
     * @return
     */
    @DeleteMapping("/del/{equipmentId}/{userId}")
    public AjaxResult del(
            @PathVariable(value = "equipmentId") Integer equipmentId,
            @PathVariable(value = "userId")Integer userId){
        return toAjax(pupuEquipmentService.del(equipmentId,userId));
    }

    /**
     * 获取当前门店的设备信息
     * @param storeId
     * @return
     */
    @GetMapping("/selectByStoreId/{storeId}")
    public AjaxResult selectByStoreId(@PathVariable(value = "storeId") Integer storeId){
        List<PupuEquipment> pupuEquipments = pupuEquipmentService.selectByStoreId(storeId);
        return AjaxResult.success(pupuEquipments);
    }

}
