package com.ruoyi.project.hit.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.hit.domain.PupuStore;
import com.ruoyi.project.hit.service.PupuStoreService;
import com.ruoyi.project.hit.service.PupuUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/hit/store")
public class PupuStoreController extends BaseController {
    @Autowired
    private PupuStoreService pupuStoreService;

    /**
     * 门店新增
     * @param pupuStore
     * @param userId（执行新增操作的用户id）
     * @return
     */
    @PutMapping("/add/{userId}")
    public AjaxResult add(
            @Validated @RequestBody PupuStore pupuStore,
            @PathVariable(value = "userId") Integer userId){
        return toAjax(pupuStoreService.add(pupuStore,userId));
    }

    /**
     * 删除门店
     * @param storeId
     * @param userId (执行删除操作的用户id）
     * @return
     */
    @DeleteMapping("/del/{storeId}/{userId}")
    public AjaxResult del(
            @PathVariable(value = "storeId")Integer storeId,
            @PathVariable(value = "userId")Integer userId){
        return toAjax(pupuStoreService.del(storeId,userId));

    }

    /**
     * 查询全部门店信息
     * @return
     */
    @GetMapping("/select")
    public TableDataInfo select(){
        List<Map<String,Object>> select = pupuStoreService.select();
        return getDataTable(select);
    }

}
