package com.ruoyi.project.hit.controller;

import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.project.hit.domain.PupuUser;
import com.ruoyi.project.hit.domain.vo.UserLoginVO;
import com.ruoyi.project.hit.service.PupuUserService;
import com.ruoyi.project.hit.util.AESUtil;
import com.ruoyi.project.hit.util.JwtUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;


@RestController
@RequestMapping("/hit/user")
public class PupuUserController extends BaseController {
    @Autowired
    private PupuUserService pupuUserService;

    @Autowired
    private RedisTemplate redisTemplate;

    @PostMapping("/login")
    public AjaxResult login(@RequestBody UserLoginVO userLoginVO){
        String encrypt = null;
        try {
            encrypt = AESUtil.encrypt(userLoginVO.getPassword());
        } catch (Exception e) {
            e.printStackTrace();
        }
        userLoginVO.setPassword(encrypt);
        PupuUser loginer = pupuUserService.login(userLoginVO);
        if(loginer!=null){
            String token = JwtUtil.generateToken(userLoginVO.getUserName());
//            System.out.println("登录token:"+token);
//            redisTemplate.opsForValue().set(token,loginer.toString(),60,TimeUnit.MINUTES);
            Map<String,Object> map=new HashMap<>();
            map.put("Token",token);
            map.put("userId",loginer.getUserId());
            return AjaxResult.success(map);
        }else {
            return AjaxResult.error("账号或密码错误");
        }
    }
    @PostMapping("/register")
    public AjaxResult register(@Validated @RequestBody PupuUser pupuUser){
        //加密存储
        String encrypt = null;
        try {
            encrypt = AESUtil.encrypt(pupuUser.getPassword());
        } catch (Exception e) {
            e.printStackTrace();
        }
        pupuUser.setPassword(encrypt);
        return toAjax(pupuUserService.register(pupuUser));
    }

}
