package com.ruoyi.project.hit.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.exception.CustomException;
import com.ruoyi.project.hit.domain.PupuEquipment;
import com.ruoyi.project.hit.domain.PupuLog;
import com.ruoyi.project.hit.mapper.PupuStoreMapper;
import com.ruoyi.project.hit.service.PupuEquipmentService;
import com.ruoyi.project.hit.mapper.PupuEquipmentMapper;
import com.ruoyi.project.hit.service.PupuLogService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * @author HP
 * @description 针对表【pupu_equipment】的数据库操作Service实现
 * @createDate 2024-09-05 16:50:18
 */
@Service
public class PupuEquipmentServiceImpl extends ServiceImpl<PupuEquipmentMapper, PupuEquipment>
        implements PupuEquipmentService {

    @Resource
    private PupuEquipmentMapper pupuEquipmentMapper;
    @Resource
    private PupuLogService pupuLogService;
    @Resource
    private PupuStoreMapper pupuStoreMapper;

    @Override
    public int add(PupuEquipment pupuEquipment, Integer userId) {
        if(pupuStoreMapper.selectById(pupuEquipment.getStoreId())==null){
            throw new CustomException("该门店不存在");
        }
        LambdaQueryWrapper<PupuEquipment> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(PupuEquipment::getSerialNumber,pupuEquipment.getSerialNumber());
        if(pupuEquipmentMapper.selectOne(wrapper)!=null){
            throw new CustomException("标识码重复");
        };
        int i=0;
        i = pupuEquipmentMapper.insertAndReturnId(pupuEquipment);
        if(i>0){
            pupuLogService.add(new PupuLog("设备"+pupuEquipment.getEquipmentId()+"新增",1,new Date(),userId));
        }
        return i;
    }

    @Override
    public int del(Integer equipmentId, Integer userId) {
        if(pupuEquipmentMapper.selectById(equipmentId)==null){
            throw new CustomException("该设备不存在");
        }
        pupuLogService.add(new PupuLog("设备"+equipmentId+"删除",2,new Date(),userId));
        return pupuEquipmentMapper.deleteById(equipmentId);
    }

    @Override
    public List<PupuEquipment> selectByStoreId(Integer storeId) {
        LambdaQueryWrapper<PupuEquipment> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(PupuEquipment::getStoreId,storeId);
        return pupuEquipmentMapper.selectList(wrapper);
    }

    @Override
    public int updateEquipmentStatus(Integer equipmentId, int i) {
        LambdaQueryWrapper<PupuEquipment> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(PupuEquipment::getEquipmentId,equipmentId);
        PupuEquipment equipment=new PupuEquipment();
        equipment.setStatus(i);
        return pupuEquipmentMapper.update(equipment,wrapper);
    }
}




