package com.ruoyi.project.hit.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.exception.CustomException;
import com.ruoyi.project.hit.domain.PupuEquipment;
import com.ruoyi.project.hit.domain.PupuLog;
import com.ruoyi.project.hit.domain.PupuStore;
import com.ruoyi.project.hit.mapper.PupuEquipmentMapper;
import com.ruoyi.project.hit.service.PupuLogService;
import com.ruoyi.project.hit.service.PupuStoreService;
import com.ruoyi.project.hit.mapper.PupuStoreMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;

/**
* @author HP
* @description 针对表【pupu_store】的数据库操作Service实现
* @createDate 2024-09-05 16:23:38
*/
@Service
public class PupuStoreServiceImpl extends ServiceImpl<PupuStoreMapper, PupuStore>
    implements PupuStoreService{

    @Resource
    private PupuStoreMapper pupuStoreMapper;
    @Resource
    private PupuLogService pupuLogService;
    @Resource
    private PupuEquipmentMapper pupuEquipmentMapper;

    @Override
    public int add(PupuStore pupuStore, Integer userId) {
        int i=0;
        i = pupuStoreMapper.insertReturnId(pupuStore);
        if(i>0){
            pupuLogService.add(new PupuLog("门店"+pupuStore.getStoreId()+"新增",1,new Date(),userId));
        }

        return i;
    }

    @Override
    public int del(Integer storeId, Integer userId) {
        LambdaQueryWrapper<PupuEquipment> wrapper=new LambdaQueryWrapper<>();
        wrapper.eq(PupuEquipment::getStoreId,storeId);

        try {
            pupuEquipmentMapper.delete(wrapper);
        }catch (Exception e){
            throw new CustomException("门店设备删除异常");
        }
        int i=pupuStoreMapper.deleteById(storeId);
        if(i>0){
            pupuLogService.add(new PupuLog("门店"+storeId+"删除",2,new Date(),userId));
        }
        return i;




    }

    @Override
    public List<Map<String, Object>> select() {
        LambdaQueryWrapper<PupuStore> wrapper=new LambdaQueryWrapper<>();
        List<PupuStore> pupuStores = pupuStoreMapper.selectList(wrapper);

        List<Map<String,Object>> list=new ArrayList<>();
        for (PupuStore pupuStore : pupuStores) {
            Map<String,Object> map=new HashMap<>();
            map.put("storeId",pupuStore.getStoreId());
            String[] arr={pupuStore.getLongitude(),pupuStore.getLatitude()};
            map.put("lnglat",arr);
            map.put("province",pupuStore.getProvince());
            map.put("city",pupuStore.getCity());
            map.put("district",pupuStore.getDistrict());
            map.put("name",pupuStore.getStoreName());
            map.put("state",pupuStore.getStatus());
            list.add(map);
        }


        return list;
    }
}




