package com.ruoyi.project.hit.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.project.hit.domain.PupuEquipment;
import com.ruoyi.project.hit.domain.PupuUpsHistory;
import com.ruoyi.project.hit.domain.vo.UpsHistoryVO;
import com.ruoyi.project.hit.mapper.PupuEquipmentMapper;
import com.ruoyi.project.hit.service.PupuUpsHistoryService;
import com.ruoyi.project.hit.mapper.PupuUpsHistoryMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
* @author HP
* @description 针对表【pupu_ups_history】的数据库操作Service实现
* @createDate 2024-09-04 13:45:24
*/
@Service
public class PupuUpsHistoryServiceImpl extends ServiceImpl<PupuUpsHistoryMapper, PupuUpsHistory>
    implements PupuUpsHistoryService{
    @Resource
    PupuUpsHistoryMapper pupuUpsHistoryMapper;
    @Resource
    private PupuEquipmentMapper pupuEquipmentMapper;
    @Override
    public List<HashMap> select(UpsHistoryVO upsHistoryVO) {
        return pupuUpsHistoryMapper.select(upsHistoryVO);
    }

    @Override
    public Map<String, Object> selectLatestHistory(Integer upsId) {
        List<HashMap> list = pupuUpsHistoryMapper.selectLatestHistory(upsId);
        Map<String,Object> objectMap=new HashMap<>();
        for (HashMap map : list) {
            objectMap.put((String) map.get("identifier"),map.get("value"));
        }
        Map<String, Object> runTime = getFirstRunTime(upsId);
        objectMap.putAll(runTime);
        return objectMap;
    }

    @Override
    public Map<String, Object> getFirstRunTime(Integer upsId) {
        Map<String,Object> map=new HashMap<>();
        PupuEquipment pupuEquipment = pupuEquipmentMapper.selectById(upsId);
        if(pupuEquipment.getStatus()==1){
            map.put("firstRunTime",null);
        }else {
            Map<String, Object> f = pupuUpsHistoryMapper.getFirstRunTime(upsId);
            map.put("firstRunTime",f.get("time"));
        }
        return map;
    }
}




