package com.ruoyi.project.hit.util;

import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;

public class AESUtil {

    // AES算法名称
    private static final String AES_ALGORITHM = "AES";

    private static final SecretKey AES_SecretKey=generateFixAESKey();


    /**
     * 生成AES密钥
     * @return SecretKey AES密钥
     * @throws NoSuchAlgorithmException 当AES算法不可用时抛出
     */
    public static SecretKey generateAESKey() throws NoSuchAlgorithmException {
        KeyGenerator keyGenerator = KeyGenerator.getInstance(AES_ALGORITHM);
        keyGenerator.init(128); // 设置密钥长度为128位
        return keyGenerator.generateKey();
    }

    /**
     * 生成AES特定密钥
     *
     * @return SecretKey AES密钥
     * @throws NoSuchAlgorithmException 当AES算法不可用时抛出
     */
    public static SecretKey generateFixAESKey(){
        // 定义一个16字节字符串key
        String fixedKey = "gpnknbndfdgzgwhh";
        // 使用固定的字节数组(128位)创建DES密钥
        return new SecretKeySpec(fixedKey.getBytes(StandardCharsets.UTF_8), "AES");
    }

    /**
     * 使用AES算法加密
     *
     * @param data      待加密的数据
     * @return 加密后的数据（Base64编码）
     * @throws Exception 加密过程中的异常
     */
    public static String encrypt(String data) throws Exception {
        Cipher cipher = Cipher.getInstance(AES_ALGORITHM);
        cipher.init(Cipher.ENCRYPT_MODE, AES_SecretKey);
        byte[] encryptedData = cipher.doFinal(data.getBytes());
        return Base64.getEncoder().encodeToString(encryptedData);
    }

    /**
     * 使用AES算法解密
     *
     * @param data       加密的数据（Base64编码）
     * @return 解密后的数据
     * @throws Exception 解密过程中的异常
     */
    public static String decrypt(String data) throws Exception {
        byte[] encryptedData = Base64.getDecoder().decode(data);
        Cipher cipher = Cipher.getInstance(AES_ALGORITHM);
        cipher.init(Cipher.DECRYPT_MODE, AES_SecretKey);
        byte[] decryptedData = cipher.doFinal(encryptedData);
        return new String(decryptedData);
    }



    // 主方法用于测试工具类
    public static void main(String[] args) {
        try {
            // 生成AES密钥
//            SecretKey secretKey = generateFixAESKey();
//            System.out.println(secretKey);
//            javax.crypto.spec.SecretKeySpec@14a23
            // 加密数据
            String originalString = "Aa123456?";
            String encryptedString = encrypt(originalString);
            System.out.println("Encrypted: " + encryptedString);

            // 解密数据
            String decryptedString = decrypt(encryptedString);
            System.out.println("Decrypted: " + decryptedString);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
