package com.ruoyi.project.hit.util.interceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ruoyi.project.hit.util.JwtUtil;
import io.jsonwebtoken.Claims;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

@Component
public class HitInterceptor implements HandlerInterceptor {
    @Autowired
    private RedisTemplate redisTemplate;

  /*  @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String token = request.getHeader("Authorization");
        System.out.println("token:" +token);
        String path = request.getRequestURI();
        System.out.println("拦截");
        if (path.startsWith("/hit") && !"/hit/user/register".equals(path) && !"/hit/user/login".equals(path) && token != null) {
            // 拦截除了/hit/user之外的所有/hit开头的请求
            // 这里可以添加你的处理逻辑，比如重定向、返回错误信息等
            if(redisTemplate.hasKey(token)){
                System.out.println("放行");
                return true;
            }
            System.out.println("打回");
            return false; // 返回false表示拦截器链中断，不再继续执行后续的Controller
        }
        // 放行/hit/user请求
        return true;


    }*/


    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String path = request.getRequestURI();
        if (path.startsWith("/hit") && !"/hit/user/register".equals(path) && !"/hit/user/login".equals(path)) {
            System.out.println("拦截");
            String token = request.getHeader("Token");
            System.out.println(token);
            if (token == null || !token.startsWith("Bearer ")) {
                response.sendError(HttpServletResponse.SC_UNAUTHORIZED, "Unauthorized");
                System.out.println("打回1");
                return false;
            }
            // 去除"Bearer "前缀
            token = token.substring(7);

            try {
                JwtUtil.myParseToken(token);// 验证token
                System.out.println("放行1");
                return true;
            } catch (Exception e) {
                response.sendError(HttpServletResponse.SC_UNAUTHORIZED, "Invalid token");
                System.out.println("打回2");
                return false;
            }
        }
        System.out.println("放行2");
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {
        // 可以在这里处理请求处理之后、视图渲染之前的逻辑
    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
        // 可以在这里处理视图渲染之后的逻辑
    }
}